<?php

if (IN_serendipity !== true) {
    die ("Don't hack!");
}


// Probe for a language include with constants. Still include defines later on, if some constants were missing
$probelang = dirname(__FILE__) . '/' . $serendipity['charset'] . 'lang_' . $serendipity['lang'] . '.inc.php';
if (file_exists($probelang)) {
    include $probelang;
}

include dirname(__FILE__) . '/lang_en.inc.php';

class serendipity_event_delayed_trackbacks extends serendipity_event {
    var $title = PLUGIN_EVENT_DELAYED_TRACKBACKS_NAME;

    function introspect(&$propbag) {
        global $serendipity;

        $propbag->add('name',          PLUGIN_EVENT_DELAYED_TRACKBACKS_NAME);
        $propbag->add('description',   PLUGIN_EVENT_DELAYED_TRACKBACKS_DESC);
        $propbag->add('stackable',     false);
        $propbag->add('author',        'Malte Paskuda');
        $propbag->add('version',       '0.1');
        $propbag->add('requirements',  array(
            'serendipity' => '0.8'
        ));
        $propbag->add('event_hooks',   array('genpage' => true,
                                             'backend_publish' => true,
                                             'backend_save' => true));
        $propbag->add('groups', array('BACKEND_FEATURES'));
    }

    function generate_content(&$title) {
        $title = $this->title;
    }

    function install() {
        $this->setupDB();
    }


    /*function introspect_config_item($name, &$propbag) {
        
    }*/


    function event_hook($event, &$bag, &$eventData) {
        global $serendipity;

        $hooks = &$bag->get('event_hooks');

        if (isset($hooks[$event])) {
            switch($event) {
                case 'backend_save':
                case 'backend_publish':
                    if (!serendipity_db_bool($entry['isdraft']) && $eventData['timestamp'] >= serendipity_serverOffsetHour()) {
                        #trackbacks couldn't get generated, so store this entry
                        $this->delay($eventData['id'], $eventData['timestamp']);
                        
                    }
                    return true;
                    break;
                case 'genpage':
                    $this->generateDelayed();
                    return true;
                    break;

                default:
                    return false;
            }
        } else {
            return false;
        }
    }

    #store id of an entry and wanted release-timestamp 
    function delay($id, $timestamp) {
        global $serendipity;
        $this->removeDelayed($id);
        $sql = "INSERT INTO
                    {$serendipity['dbPrefix']}delayed_trackbacks (id, timestamp)
                VALUES
                    ({$id}, {$timestamp})";
        serendipity_db_query($sql);
    }

    #generate trackbacks for entries which now are shown
    function generateDelayed() {
        global $serendipity;
        include_once S9Y_INCLUDE_PATH . 'include/functions_trackbacks.inc.php';
        
        $sql = "SELECT id, timestamp
                FROM
                    {$serendipity['dbPrefix']}delayed_trackbacks";
        $entries = serendipity_db_query($sql);

        if  (!empty($entries[0])) {
            foreach ($entries as $entry) {
                if ($entry['timestamp'] <= serendipity_serverOffsetHour()) {
                    
                    $stored_entry = serendipity_fetchEntry('id', $entry['id'], 1, 1);
                    $_SESSION['serendipityRightPublish'] = true;
                    #remove unnatural entry-data which let the update fail
                    if (isset($stored_entry['loginname'])) {
                        unset($stored_entry['loginname']);
                    }
                    if (isset($stored_entry['email'])) {
                        unset($stored_entry['email']);
                    }
                    serendipity_updertEntry($stored_entry);
                    
                    #the trackbacks are now generated
                    $this->removeDelayed($entry['id']);
                }
            }
        }
    }

    #remove delayed entry from further use
    function removeDelayed($id) {
        global $serendipity;
        $sql = "DELETE FROM
                 {$serendipity['dbPrefix']}delayed_trackbacks
                 WHERE id={$id}";
        serendipity_db_query($sql);
    }

    function setupDB() {
	    global $serendipity;
		$sql = "CREATE TABLE {$serendipity['dbPrefix']}delayed_trackbacks (
`id` int(11) NOT NULL ,
`timestamp` int(10) unsigned default NULL,
PRIMARY KEY ( `id` )
)";
		serendipity_db_query ( $sql );
    }

    function debugMsg($msg) {
		global $serendipity;
		
		$this->debug_fp = @fopen ( $serendipity ['serendipityPath'] . 'templates_c/delayed_trackbacks.log', 'a' );
		if (! $this->debug_fp) {
			return false;
		}
		
		if (empty ( $msg )) {
			fwrite ( $this->debug_fp, "failure \n" );
		} else {
			fwrite ( $this->debug_fp, print_r ( $msg, true ) );
		}
		fclose ( $this->debug_fp );
	}

}

/* vim: set sts=4 ts=4 expandtab : */
?>
